﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ASTRO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            combo_UT_ET.SelectedIndex = 0;

            Swe.SweInicialize();  //Set Sweph default directory
        }



        private void button2_Click(object sender, EventArgs e)
        {

            int[] y = new int[1];
            int[] m = new int[1];
            int[] d = new int[1];
            double[] dh = new double[1];
            double[] jd = new double[1];
            int iday, imonth, iyear, ihour, imin, isec;
            double[] xx = new double[20];
            double tjd, tjdet, tjdut, dhour, deltat;
            String sjul, sout;
            double[] hcusps = new double[13];
            double[] ascmc = new double[9];
            char[] hsys = new char[] { 'P', 'K', 'R', 'C', 'E' };


            listBox1.Items.Clear();

            iday = dateTimePicker1.Value.Day;
            imonth = dateTimePicker1.Value.Month;
            iyear = dateTimePicker1.Value.Year;
            ihour = dateTimePicker1.Value.Hour;
            imin = dateTimePicker1.Value.Minute;
            isec = dateTimePicker1.Value.Second;

            dhour = ihour + imin / 60.0 + isec / 3600.0;
            tjd = Swe.Function.swe_julday(iyear, imonth, iday, dhour, 1);  //Calculate julday from date
            deltat = Swe.Function.swe_deltat(tjd);                         //Calculate deltat


            //---------------------------------------------------------------------------------------------------------------------------
            // Print Delta and start julian day
            if (combo_UT_ET.SelectedIndex == 0)
            {
                sjul = (deltat * 86400).ToString();
                sout = "deltat:     " + sjul + " sec";

                listBox1.Items.Add(sout);
                tjdut = tjd;
                tjdet = tjd + deltat;
                sjul = tjdut.ToString();
                sjul = sjul + " UT";
            }
            else
            {
                //{input date is Ephemeris Time}
                tjdet = tjd;
                tjdut = tjd - deltat;
                sjul = tjdet.ToString();
                sjul = sjul + " ET";
            }


            sout = "from julDay:   " + sjul;

            listBox1.Items.Add(sout);
            //listBox1.Items.Add("================================================");
            listBox1.Items.Add("");
            


            /////////////////////Planet to degree test////////////////////////////
            int flags = Swe.Constant.SEFLG_SWIEPH + Transit.Constant.SEFLG_TRANSIT_LONGITUDE;// +Swe.Constant.SEFLG_TRANSIT_SPEED;
            bool back = false;

            SwissEph sw = new SwissEph();

            TransitCalculator tc = new TCPlanet(
                                  sw,
                                  Convert.ToInt32(comboBox1.Text),      //Planet number
                                  flags,                                //flags  
                                  Convert.ToDouble(textBox1.Text));     //target degree

            double nextTransitUT = sw.getTransitUT(tc, tjdut, back);


            Swe.Function.swe_revjul(nextTransitUT, 1, y, m, d, dh);
            DateTime date = new DateTime(y[0], m[0], d[0]); //Convert julday to date
            date = date.AddHours(dh[0]);
            listBox1.Items.Add("------------------------------------TCPlanet--------------------------------------------");
            listBox1.Items.Add("julDay: " + nextTransitUT.ToString() + "      Date: " + date.ToString());
            listBox1.Items.Add("");




            /////////////////////PlanetPlanet to distance test////////////////////////
            flags = Swe.Constant.SEFLG_SWIEPH + Transit.Constant.SEFLG_TRANSIT_LONGITUDE;

            sw = new SwissEph();

            tc = new TCPlanetPlanet(
                sw,
                Convert.ToInt32(comboBox2.Text),    //Planet number1
                Convert.ToInt32(comboBox3.Text),    //Planet number2
                flags,                              //flags
                Convert.ToInt32(textBox2.Text));    //target distance degree

            nextTransitUT = sw.getTransitUT(tc, tjdut, back);


            Swe.Function.swe_revjul(nextTransitUT, 1, y, m, d, dh);
            date = new DateTime(y[0], m[0], d[0]);  //Convert julday to date
            date = date.AddHours(dh[0]);
            listBox1.Items.Add("-------------------------------TCPlanetPlanet---------------------------------------");
            listBox1.Items.Add("julDay: " + nextTransitUT.ToString() + "      Date: " + date.ToString());
            listBox1.Items.Add("");




            ///////////////////////House to degree test//////////////////////////////
            flags = Transit.Constant.SEFLG_TRANSIT_LONGITUDE;
            double geolon = 19.0667;
            double geolat = 47.5;


            sw = new SwissEph();

            tc = new TCHouses(
               sw,
               Convert.ToInt32(comboBox4.Text),     //House (or other axis) number
               hsys[0],                             //House system
               geolon,                              //Geo Longitude coordinate
               geolat,                              //Geo Latitude coordinate
               flags,                               //flags
               Convert.ToInt32(textBox3.Text));     //target degree

            nextTransitUT = sw.getTransitUT(tc, tjdut, back);


            Swe.Function.swe_revjul(nextTransitUT, 1, y, m, d, dh);  //Convert julday to date 
            date = new DateTime(y[0], m[0], d[0]);
            date = date.AddHours(dh[0]);
            listBox1.Items.Add("------------------------------------TCHouses------------------------------------------");
            listBox1.Items.Add("julDay: " + nextTransitUT.ToString() + "      Date: " + date.ToString());

        }







    }
}
