﻿using System;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;

namespace ASTRO
{
    public static class Swe
    {
        //Swe method_______________________________________________________________________________________________________
        public static void SweInicialize()
        {

            Function.swe_set_ephe_path(Directory.GetCurrentDirectory() + "\\Sweph");
             
        }

        //Swe AstroConstant________________________________________________________________________________________________
        public static class Constant
        {
            /* planet numbers for the ipl parameter in swe_calc() */
            public const int SE_ECL_NUT = -1;
            public const int SE_SUN = 0;
            public const int SE_MOON = 1;
            public const int SE_MERCURY = 2;
            public const int SE_VENUS = 3;
            public const int SE_MARS = 4;
            public const int SE_JUPITER = 5;
            public const int SE_SATURN = 6;
            public const int SE_URANUS = 7;
            public const int SE_NEPTUNE = 8;
            public const int SE_PLUTO = 9;
            public const int SE_MEAN_NODE = 10;
            public const int SE_TRUE_NODE = 11;
            public const int SE_MEAN_APOG = 12;
            public const int SE_OSCU_APOG = 13;
            public const int SE_EARTH = 14;
            public const int SE_CHIRON = 15;
            public const int SE_PHOLUS = 16;
            public const int SE_CERES = 17;
            public const int SE_PALLAS = 18;
            public const int SE_JUNO = 19;
            public const int SE_VESTA = 20;
            public const int SE_INTP_APOG = 21;
            public const int SE_INTP_PERG = 22;

            public const int SE_NPLANETS = 23;
            public const int SE_FICT_OFFSET = 40;
            public const int SE_NFICT_ELEM = 15;

            /* Hamburger or Uranian "planets" */

            public const int SE_CUPIDO = 40;
            public const int SE_HADES = 41;
            public const int SE_ZEUS = 42;
            public const int SE_KRONOS = 43;
            public const int SE_APOLLON = 44;
            public const int SE_ADMETOS = 45;
            public const int SE_VULKANUS = 46;
            public const int SE_POSEIDON = 47;

            /* other fictitious bodies */

            public const int SE_ISIS = 48;
            public const int SE_NIBIRU = 49;
            public const int SE_HARRINGTON = 50;
            public const int SE_NEPTUNE_LEVERRIER = 51;
            public const int SE_NEPTUNE_ADAMS = 52;
            public const int SE_PLUTO_LOWELL = 53;
            public const int SE_PLUTO_PICKERING = 54;

            public const int SE_AST_OFFSET = 10000;

         
            public const int SEFLG_JPLEPH = 1;	// use JPL ephemeris 
            public const int SEFLG_SWIEPH = 2;	// use SWISSEPH ephemeris, default
            public const int SEFLG_MOSEPH = 4;	// use Moshier ephemeris 

            public const int SEFLG_HELCTR = 8;	// return heliocentric position 
            public const int SEFLG_TRUEPOS = 16;	// return true positions, not apparent 
            public const int SEFLG_J2000 = 32;	// no precession, i.e. give J2000 equinox 
            public const int SEFLG_NONUT = 64;	// no nutation, i.e. mean equinox of date 
            public const int SEFLG_SPEED3 = 128;	// speed from 3 positions (do not use it, SEFLG_SPEED is faster and preciser.) 

            public const int SEFLG_SPEED = 256;	// high precision speed (analyt. comp.)
            public const int SEFLG_NOGDEFL = 512;	// turn off gravitational deflection 
            public const int SEFLG_NOABERR = 1024;	// turn off 'annual' aberration of light 
            public const int SEFLG_EQUATORIAL = 2048;	// equatorial positions are wanted 
            public const int SEFLG_XYZ = 4096;	// cartesian, not polar, coordinates 
            public const int SEFLG_RADIANS = 8192;	// coordinates in radians, not degrees 
            public const int SEFLG_BARYCTR = 16384;	// barycentric positions 
            public const int SEFLG_TOPOCTR = (32 * 1024);	// topocentric positions 
            public const int SEFLG_SIDEREAL = (64 * 1024);	// sidereal positions 

            public const int SE_NODBIT_MEAN = 1;
            public const int SE_NODBIT_OSCU = 2;
            public const int SE_NODBIT_OSCU_BAR = 4;
            public const int SE_NODBIT_FOPOINT = 256;

            public const int SE_ECL_CENTRAL = 1;
            public const int SE_ECL_NONCENTRAL = 2;
            public const int SE_ECL_TOTAL = 4;
            public const int SE_ECL_ANNULAR = 8;
            public const int SE_ECL_PARTIAL = 16;
            public const int SE_ECL_ANNULAR_TOTAL = 32;

            public const int SE_CALC_RISE = 1;
            public const int SE_CALC_SET = 2;
            public const int SE_CALC_MTRANSIT = 4;	/* upper meridian transit (southern for northern geo. latitudes) */
            public const int SE_CALC_ITRANSIT = 8;	/* lower meridian transit (northern, below the horizon) */

            public const int SE_BIT_DISC_CENTER = 256;	/* for rising or setting of disc center */
            public const int SE_BIT_DISC_BOTTOM = 8192;	 /* for rising or setting of lower limb of disc */
            public const int SE_BIT_NO_REFRACTION = 512;	 /* if refraction is not to be considered */
            public const int SE_BIT_CIVIL_TWILIGHT = 1024;	/* in order to calculate civil twilight */
            public const int SE_BIT_NAUTIC_TWILIGHT = 2048;	/* in order to calculate nautical twilight */
            public const int SE_BIT_ASTRO_TWILIGHT = 4096;	/* in order to calculate astronomical twilight */
            public const int SE_BIT_FIXED_DISC_SIZE = 16 * 1024;	/* neglect the effect of distance on disc size */

            public const int SE_ECL2HOR = 0;
            public const int SE_EQU2HOR = 1;

            public const int SE_HOR2ECL = 0;
            public const int SE_HOR2EQU = 1;

            public const int SE_TRUE_TO_APP = 0;
            public const int SE_APP_TO_TRUE = 1;

            public const int SE_SIDM_FAGAN_BRADLEY = 0;
            public const int SE_SIDM_LAHIRI = 1;
            public const int SE_SIDM_DELUCE = 2;
            public const int SE_SIDM_RAMAN = 3;
            public const int SE_SIDM_USHASHASHI = 4;
            public const int SE_SIDM_KRISHNAMURTI = 5;
            public const int SE_SIDM_DJWHAL_KHUL = 6;
            public const int SE_SIDM_YUKTESHWAR = 7;
            public const int SE_SIDM_JN_BHASIN = 8;
            public const int SE_SIDM_BABYL_KUGLER1 = 9;
            public const int SE_SIDM_BABYL_KUGLER2 = 10;
            public const int SE_SIDM_BABYL_KUGLER3 = 11;
            public const int SE_SIDM_BABYL_HUBER = 12;
            public const int SE_SIDM_BABYL_ETPSC = 13;
            public const int SE_SIDM_ALDEBARAN_15TAU = 14;
            public const int SE_SIDM_HIPPARCHOS = 15;
            public const int SE_SIDM_SASSANIAN = 16;
            public const int SE_SIDM_GALCENT_0SAG = 17;
            public const int SE_SIDM_J2000 = 18;
            public const int SE_SIDM_J1900 = 19;
            public const int SE_SIDM_B1950 = 20;
            public const int SE_SIDM_USER = 255;

            /* for projection onto ecliptic of t0 */
            public const int SE_SIDBIT_ECL_T0 = 256;

            /* for projection onto solar system rotation plane */
            public const int SE_SIDBIT_SSY_PLANE = 512;

            //The following defines can be used to find these values:	
            public const int SE_ASC = 0;
            public const int SE_MC = 1;
            public const int SE_ARMC = 2;
            public const int SE_VERTEX = 3;
            public const int SE_EQUASC = 4;	/* "equatorial ascendant" */
            public const int SE_COASC1 = 5;	/* "co-ascendant" (W. Koch) */
            public const int SE_COASC2 = 6;	/* "co-ascendant" (M. Munkasey) */
            public const int SE_POLASC = 7;	/* "polar ascendant" (M. Munkasey) */
            public const int SE_NASCMC = 8;

            public const string Placidus = "P";	// Placidus
            public const string Koch = "K";	// Koch
            public const string Porphyrius = "O";	// Porphyrius
            public const string Regiomontanus = "R";	// Regiomontanus
            public const string Campanus = "C";	// Campanus
            public const string Equal_A = "A";	// Equal (cusp 1 is Ascendant)
            public const string Equal_B = "E";	// Equal (cusp 1 is Ascendant)
            public const string Vehlow_equal = "V";	// Vehlow equal (Asc. in middle of house 1)
            public const string Whole_sign = "W";	// Whole sign 
            public const string axial_rotation_system = "X";	// axial rotation system
            public const string azimuthal_or_horizontal_system = "H";	// azimuthal or horizontal system
            public const string Polich_or_Page_topocentric_sys = "T";	// Polich/Page ("topocentric" system)
            public const string Alcabitus = "B";	// Alcabitus
            public const string Morinus = "M";	// Morinus
            public const string Krusinski_Pisa = "U";	// Krusinski-Pisa
            public const string Gauquelin_sectors = "G";	// Gauquelin sectors
        }

        //Swe Functions____________________________________________________________________________________________________
        public static class Function
        {
           
            [DllImport("swedll32.dll", EntryPoint = "swe_calc")]
            public static extern Int32 swe_calc(double tjd, int ipl, Int32 iflag, double[] xx, StringBuilder serr);
           
            [DllImport("swedll32.dll", EntryPoint = "swe_calc_ut")]
            public static extern Int32 swe_calc_ut(double tjd_ut, Int32 ipl, Int32 iflag, double[] xx, StringBuilder serr);
           
            [DllImport("swedll32.dll", EntryPoint = "swe_date_conversion")]
            public static extern int swe_date_conversion(int y, int m, int d, /* day, month, year */ double uttime, /* UT in hours (decimal) */ char c, /* calendar g[regorian]|j[ulian] */ double[] tjd);
        
            [DllImport("swedll32.dll", EntryPoint = "swe_deltat")]
            public static extern double swe_deltat(double tjd);
            
            [DllImport("swedll32.dll", EntryPoint = "swe_houses_ex")]
            public static extern int swe_houses_ex(double tjd_ut, Int32 iflag, double geolat, double geolon, int hsys, double[] cusp, double[] ascmc);
           
            [DllImport("swedll32.dll", EntryPoint = "swe_revjul")]
            public static extern void swe_revjul(double jd, int gregflag, int[] jyear, int[] jmon, int[] jday, double[] jut);
            
            [DllImport("swedll32.dll", EntryPoint = "swe_set_ephe_path")]
            public static extern void swe_set_ephe_path(String path);

            [DllImport("swedll32.dll", EntryPoint = "swe_set_topo")]
            public static extern void swe_set_topo(double geolon, double geolat, double geoalt);

            [DllImport("swedll32.dll", EntryPoint = "swe_julday")]
            public static extern double swe_julday(int year, int month, int day, double hour, int gregflag);
          
           
        }

      
    }
}